// countdownDlg.cpp : implementation file
//
// Copyright 2003, Ilya Mironov & Dmitry Teytelman

#include "stdafx.h"
#include <mmsystem.h>
#include <windows.h>
#include <iostream.h>

#include "countdown.h"
#include "countdownDlg.h"
#include "wincomm/serial.h"
#include "wincomm/mcr.h"
#include "scoretable.h"
#include "teams.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const COLORREF BLACK = RGB(0,0,0);
const COLORREF RED = RGB(255,0,0);
const COLORREF YELLOW = RGB(255,255,0);
const COLORREF GREEN = RGB(0,255,0);

BRSTATE currBRState;
SISTATE currSIState;
BMSTATE currBMState;

TCHAR COMPORT[] = "com2";

const int HOSTBUTTON = 11;

const int MAX = 60;
const int BRSECONDMAX = 20;

const int BMSECONDMAX = 20;


const int SIMAX = 5;
const int SISECONDMAX = 5;
const int SITIMEOUT = 3;
const int SITIMECOOLOFF = 3;

enum EVENTS {EVENTUPDATE, EVENTPOLL, EVENTSICOOLOFF, EVENTDELAY};

bool bTimer = false;
bool bAnswering = false;
bool bBlitz = false;
int nBlitzTeam;
int nBlitz = 0;

int currSpeed = 1;

DWORD currStartTime;
DWORD currElapsed;

int nSITimeOut;

long arAntiBounce[MCR_BUTTONS];
const long BOUNCECUTOFF = 4000;

const int YGAPTOP = 10;
const int YGAPBOTTOM = 5;
const int YGAPBETWEEN = 2;
const int YHEIGHTMAX = 60;

int currCounter;

// CcountdownDlg dialog


// CCounter dialog

IMPLEMENT_DYNAMIC(CcountdownDlg, CPropertyPage)
CcountdownDlg::CcountdownDlg(int _IDD)
	: CPropertyPage(_IDD, IDS_COUNTDOWN)
{
	cerr << _IDD;
}


// CCounter message handlers


void CcountdownDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_START60, CBStart60);
	DDX_Control(pDX, IDC_STOP, CBStop);
	DDX_Control(pDX, IDC_START30, CBStart30);
	DDX_Control(pDX, IDC_SOLD, labelSold);
	DDX_Control(pDX, IDC_BIDDERNAME, m_bidderName);
	DDX_Control(pDX, IDC_TNUM1, m_teamcards[0].m_tnum);
	DDX_Control(pDX, IDC_TNAME1, m_teamcards[0].m_tname);
	DDX_Control(pDX, IDC_TMONEY1, m_teamcards[0].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS1, m_teamcards[0].m_tpoints);
	DDX_Control(pDX, IDC_TNUM2, m_teamcards[1].m_tnum);
	DDX_Control(pDX, IDC_TNAME2, m_teamcards[1].m_tname);
	DDX_Control(pDX, IDC_TMONEY2, m_teamcards[1].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS2, m_teamcards[1].m_tpoints);
	DDX_Control(pDX, IDC_TNUM3, m_teamcards[2].m_tnum);
	DDX_Control(pDX, IDC_TNAME3, m_teamcards[2].m_tname);
	DDX_Control(pDX, IDC_TMONEY3, m_teamcards[2].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS3, m_teamcards[2].m_tpoints);
	DDX_Control(pDX, IDC_TNUM4, m_teamcards[3].m_tnum);
	DDX_Control(pDX, IDC_TNAME4, m_teamcards[3].m_tname);
	DDX_Control(pDX, IDC_TMONEY4, m_teamcards[3].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS4, m_teamcards[3].m_tpoints);
	DDX_Control(pDX, IDC_TNUM5, m_teamcards[4].m_tnum);
	DDX_Control(pDX, IDC_TNAME5, m_teamcards[4].m_tname);
	DDX_Control(pDX, IDC_TMONEY5, m_teamcards[4].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS5, m_teamcards[4].m_tpoints);
	DDX_Control(pDX, IDC_TNUM6, m_teamcards[5].m_tnum);
	DDX_Control(pDX, IDC_TNAME6, m_teamcards[5].m_tname);
	DDX_Control(pDX, IDC_TMONEY6, m_teamcards[5].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS6, m_teamcards[5].m_tpoints);
	DDX_Control(pDX, IDC_TNUM7, m_teamcards[6].m_tnum);
	DDX_Control(pDX, IDC_TNAME7, m_teamcards[6].m_tname);
	DDX_Control(pDX, IDC_TMONEY7, m_teamcards[6].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS7, m_teamcards[6].m_tpoints);
	DDX_Control(pDX, IDC_TNUM8, m_teamcards[7].m_tnum);
	DDX_Control(pDX, IDC_TNAME8, m_teamcards[7].m_tname);
	DDX_Control(pDX, IDC_TMONEY8, m_teamcards[7].m_tmoney);
	DDX_Control(pDX, IDC_TPOINTS8, m_teamcards[7].m_tpoints);
	DDX_Control(pDX, IDC_LABELCREDIT, m_labelcredit);
	DDX_Control(pDX, IDC_COMBO1, m_questionvalue);
	DDX_Control(pDX, IDC_LABELQUESTIONVALUE, m_labelquestionvalue);
	DDX_Control(pDX, IDC_LABELBUTTON, m_labelbutton);
	DDX_Control(pDX, IDC_LABELNAME, m_labelname);
	DDX_Control(pDX, IDC_LABELSCORE, m_labelscore);
	DDX_Control(pDX, IDC_RESET, m_buttonreset);
	DDX_Control(pDX, IDC_TIMER2, m_timer2);
	DDX_Control(pDX, IDC_TIMER1, m_timer1);
	DDX_Control(pDX, IDC_TIMER3, m_timer3);
	DDX_Control(pDX, IDC_CHECK1, m_multiply2);
	DDX_Control(pDX, IDC_CHECK2, m_transparent);
}

BEGIN_MESSAGE_MAP(CcountdownDlg, CPropertyPage)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
	ON_BN_CLICKED(IDC_START60, OnBnClickedStart60)
	ON_BN_CLICKED(IDC_START30, OnBnClickedStart30)
	ON_BN_CLICKED(IDC_RESUME, OnBnClickedResume)
//	ON_WM_KEYDOWN()
//ON_WM_CHAR()
ON_WM_DESTROY()
ON_BN_CLICKED(IDC_RESET, OnBnClickedReset)
//ON_STN_CLICKED(IDC_SOLD, OnStnClickedSold)
ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
ON_BN_CLICKED(IDC_CHECK2, OnBnClickedCheck2)
//ON_WM_ACTIVATE()
END_MESSAGE_MAP()


// CcountdownDlg message handlers

BOOL CcountdownDlg::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here


	hComPort = SerialInit(COMPORT, 57600);
	if( hComPort == 0) {
		CString s;
		s.Format("Error initializing %s!\n", COMPORT);
		MessageBox(s, "Error", MB_ICONERROR | MB_OK);
		printf("Error initializing %s!\n", COMPORT);
		return FALSE;
	}

	SetTimer(EVENTUPDATE, 10, NULL); 
	SetTimer(EVENTPOLL, 10, NULL); 

	// Use AfxGetApp() to get pointer to CWinApp-derived
    // object; then cast the pointer to our type and assign
    ((CcountdownApp *)AfxGetApp())->m_hwndDialog = m_hWnd;

	m_timer1.SetFontBold(true);
	m_timer1.SetFontName(TEXT("Tahoma"));
	m_timer1.SetFontSize(320);
	m_timer2.SetFontBold(true);
	m_timer2.SetFontName(TEXT("Tahoma"));
	m_timer2.SetFontSize(320);
	m_timer3.SetFontBold(true);
	m_timer3.SetFontName(TEXT("Tahoma"));
	m_timer3.SetFontSize(320);

	SetCounter(-1, BLACK);

	switch(currGame){
		case GAMEBRAINCION:
		case GAMEBRAINMULT:
			labelSold.SetFontSize(72);
			break;
		case GAMEBRAINRING:
			labelSold.SetFontSize(44);
			break;
		case GAMESVOYAK:
			labelSold.SetFontSize(72);
			break;
	}

	labelSold.SetTextColor(RED);
	labelSold.SetFontBold(true);
	labelSold.SetText("");
	labelSold.SetTransparency(true);

	m_bidderName.SetFontSize(28);
	m_bidderName.SetTextColor(RED);
	m_bidderName.SetText("");
	m_bidderName.SetTransparency(true);
	m_bidderName.SetFontBold(true);
//	m_bidderName.BringWindowToTop();

	m_scorefont.CreateFont(24, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, "Arial");
	m_choicefont.CreateFont(24, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, "Arial");

	for(int i = 0; i < currTeams; i++){
		switch(currGame){
		case GAMEBRAINCION:
				m_teamcards[i].m_tmoney.SetFont(&m_scorefont);
				break;
		case GAMEBRAINMULT:
				break;
		case GAMEBRAINRING:
				break;
		case GAMESVOYAK:
				break;
		}
		m_teamcards[i].m_tnum.SetFont(&m_scorefont);
		m_teamcards[i].m_tname.SetFont(&m_scorefont);
		m_teamcards[i].m_tpoints.SetFont(&m_scorefont);
	}

	m_questionvalue.SetFont(&m_choicefont);
	m_buttonreset.SetWindowText("");

	switch(currGame){
		case GAMEBRAINCION:
			CBStart60.SetWindowText("");
			CBStart30.ShowWindow(SW_HIDE); //SetWindowText("");

			for(int i = 0; i < 8; i++)
				m_teamcards[i].m_tmoney.ShowWindow(SW_SHOW);

			m_labelcredit.ShowWindow(SW_SHOW);
			m_labelcredit.SetWindowText("");
			m_labelquestionvalue.ShowWindow(SW_SHOW);
			m_labelquestionvalue.SetWindowText("");
			m_questionvalue.ShowWindow(SW_SHOW);
			m_questionvalue.AddString("x1");
			m_questionvalue.AddString("x2");
			m_questionvalue.AddString("x3");
			m_questionvalue.AddString("x4");
			m_questionvalue.SetCurSel(0);
			m_multiply2.ShowWindow(SW_SHOW);
			m_multiply2.SetCheck(BST_UNCHECKED);
			m_multiply2.SetWindowText("");
			break;
		case GAMEBRAINMULT:
			CBStart60.SetWindowText("");
			CBStart30.SetWindowText("!");
			m_labelquestionvalue.ShowWindow(SW_SHOW);
			m_labelquestionvalue.SetWindowText(" ");
			m_questionvalue.ShowWindow(SW_SHOW);
			m_questionvalue.AddString("1");
			m_questionvalue.AddString("2");
			m_questionvalue.AddString("3");
			m_questionvalue.SetCurSel(0);
			break;
		case GAMEBRAINRING:
			m_questionvalue.SetCurSel(0);
			break;
		case GAMESVOYAK:
			m_labelname.SetWindowText(" ");
			m_questionvalue.ShowWindow(SW_SHOW);
			m_labelquestionvalue.ShowWindow(SW_SHOW);
			m_labelquestionvalue.SetWindowText(" ");
			CBStart60.SetWindowText("!");
			CBStart30.ShowWindow(SW_HIDE);
			m_multiply2.ShowWindow(SW_SHOW);
			m_multiply2.SetCheck(BST_UNCHECKED);
			m_questionvalue.AddString("10");
			m_questionvalue.AddString("20");
			m_questionvalue.AddString("30");
			m_questionvalue.AddString("40");
			m_questionvalue.AddString("50");
			m_questionvalue.SetCurSel(0);
			break;
	}		

	UpdateScoreCards();

	OnBnClickedReset(); // reset the whole thing

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CcountdownDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
	}
	else
	{
		CPropertyPage::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CcountdownDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPropertyPage::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CcountdownDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CcountdownDlg::OnBnClickedOk()
{
}

void CcountdownDlg::SetCounter(int nCounter, COLORREF nColor){
		currCounter = nCounter;

		if(currTimerColor != nColor){
			m_timer1.SetTextColor(nColor);
			m_timer2.SetTextColor(nColor);
			m_timer3.SetTextColor(nColor);
			currTimerColor = nColor;
		}

		CString p1 = "", p2 = "", p3 = "", p1old, p2old, p3old;
		m_timer1.GetWindowText(p1old);
		m_timer2.GetWindowText(p2old);
		m_timer3.GetWindowText(p3old);

		if(nCounter >= 0){
			if(nCounter >= 10){
				p1.Format("%d", nCounter / 10);
				p2.Format("%d", nCounter % 10);
				m_timer3.ShowWindow(SW_HIDE);
			}else{
				m_timer3.ShowWindow(SW_SHOW);
				p3.Format("%d", nCounter);
			}
		}

		if(p1 != p1old) m_timer1.SetText(p1);
		if(p2 != p2old) m_timer2.SetText(p2);
		if(p3 != p3old) m_timer3.SetText(p3);
}


void CcountdownDlg::InvalidateCounter(){
	CString s;
	m_timer1.GetWindowText(s); if(s.IsEmpty()) m_timer1.SetText(s);
	m_timer2.GetWindowText(s); if(s.IsEmpty()) m_timer2.SetText(s);
	m_timer3.GetWindowText(s); if(s.IsEmpty()) m_timer3.SetText(s);

	m_timer1.GetWindowText(s); if(!s.IsEmpty()) m_timer1.SetText(s);
	m_timer2.GetWindowText(s); if(!s.IsEmpty()) m_timer2.SetText(s);
	m_timer3.GetWindowText(s); if(!s.IsEmpty()) m_timer3.SetText(s);
}

void CcountdownDlg::UpdateCounter(){
	DWORD currTime = timeGetTime();
	currElapsed = currTime - currStartTime;
	long int seconds = (currSpeed * currElapsed) / 1000 ;

	switch(currGame){
		case GAMEBRAINCION:
			if(bTimer){
				int nCounter;
				
				int nTimeOverPeriod = bBlitz? 1 : 3;

				if(seconds >= MAX + 3 * nTimeOverPeriod * currSpeed){
					ResetTimer(false);
					CBStart30.SetFocus();
//					PlaySound(_T("gong.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
					nCounter = MAX;
					if(bBlitz) nBlitzTeam = -1;
				}else if(seconds >= MAX) nCounter = 1;
				else
					nCounter = MAX - seconds;

				COLORREF newcurrColor = BLACK;
	
				if(!bTimer || (seconds < MAX))
					newcurrColor = BLACK;     // pitch black
				else if(seconds >= MAX + 2 * nTimeOverPeriod  * currSpeed)
					newcurrColor =  RED;// red
				else if(seconds >= MAX + nTimeOverPeriod  * currSpeed)
					newcurrColor =  YELLOW;// yellow
				else if(seconds >= MAX)
					newcurrColor = GREEN; // green
				SetCounter(nCounter, newcurrColor);
			}
			break;

		case GAMEBRAINMULT:
			switch(currBMState){
				case BMQUESTION:
					SetCounter(60, RED);
					break;
				case BMBEEP1:
				case BMBEEP2:
					if(currElapsed > 1000){
						currSpeed = 1;
						currStartTime = timeGetTime();
						if(currBMState == BMBEEP1){
							currBMState = BMMINUTE;
							SetCounter(MAX, BLACK);
						}else{
							currBMState = BMSECOND;
							SetCounter(BMSECONDMAX, BLACK);
						}
					}
					break;
				case BMMINUTE:
					int nCounter;
					if(seconds >= MAX)
						QuestionExpires();
					else{
						nCounter = MAX - seconds;
						SetCounter(nCounter, BLACK);
					}
					break;
				case BMSECOND:
					if(seconds >= BMSECONDMAX)
						QuestionExpires();
					else{
						nCounter = BMSECONDMAX - seconds;
						SetCounter(nCounter, BLACK);
					}
				case BMANSWERING:
					break;
			}
			break;

		case GAMEBRAINRING:
			switch(currBRState){
				case BRQUESTION:
				case BRDELAY:
					SetCounter(60, RED);
					break;
				case BRBEEP1:
				case BRBEEP2:
					if(currElapsed > 1000){
						currSpeed = 1;
						currStartTime = timeGetTime();
						if(currBRState == BRBEEP1){
							currBRState = BRMINUTE;
							SetCounter(MAX, BLACK);
						}else{
							currBRState = BRSECOND;
							SetCounter(BRSECONDMAX, BLACK);
						}
					}
					break;
				case BRMINUTE:
					int nCounter;

					if(seconds >= MAX)
						QuestionExpires();
					else{
						nCounter = MAX - seconds;
						SetCounter(nCounter, BLACK);
					}
					break;
				case BRSECOND:
					if(seconds >= BRSECONDMAX)
						QuestionExpires();
					else{
						nCounter = BRSECONDMAX - seconds;
						SetCounter(nCounter, BLACK);
					}
				case BRANSWERING:
					break;
			}
			break;
		case GAMESVOYAK:
			switch(currSIState){
				case SITIMER:
					int nCounter;

					if(seconds >= SIMAX)
						QuestionExpires();
					else{
						nCounter = SIMAX - seconds;
                        SetCounter(nCounter, BLACK);
					}
					break;
				case SIANSWERING:
				case SICOOLOFF:
					break;
			}
			break;
	}
}

void CcountdownDlg::ProcessBid(int nTeam, int nBid){
	bool bTimerOld;
	CString s, v, strElapsed;
	int oldElapsed = currElapsed;

	int nCanAnswer; nCanAnswer = 0;
	for(int i = 0; i < currTeams; i++)
		if(CanAnswer(i)) nCanAnswer++;

	strElapsed = "";

	if(currElapsed < 5000){
		switch(currGame){
			case GAMEBRAINCION:
				if(bTimer)
					strElapsed.Format("(%d ms)", currElapsed);
				break;
			case GAMEBRAINMULT:
				switch(currBMState){
					case BMBEEP1:
					case BMBEEP2:
					case BMSECOND:
						strElapsed.Format("(%d ms)", currElapsed);
						break;
					case BMMINUTE:
						strElapsed.Format("(%d ms)", currElapsed + 1000);
						break;
				}
				break;

			case GAMEBRAINRING:
				switch(currBRState){
					case BRBEEP1:
					case BRBEEP2:
					case BRSECOND:
						strElapsed.Format("(%d ms)", currElapsed);
						break;
					case BRMINUTE:
						strElapsed.Format("(%d ms)", currElapsed + 1000);
						break;
				}
				break;
			case GAMESVOYAK:
				if(currSIState == SITIMER)
					strElapsed.Format("(%d ms)", currElapsed);
				break;
		}
	}

//	DWORD currTime = timeGetTime();
//	currElapsed = currTime - currStartTime;


	switch(currGame){
	case GAMEBRAINCION:
		bAnswering = true;
		bTimerOld = bTimer; 
		ResetTimer(false);

		labelSold.SetText("");
		m_bidderName.SetText(teamArray[nTeam].m_name);
		PlaySound(_T("hammer.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);

		s.Format("  \"%s\" ( %d).  ?",teamArray[nTeam].m_name,teamArray[nTeam].m_label);

		if(bBlitz)	v.Format(":  %d", nBlitz);
		else v.Format(" " + strElapsed);

		switch(MessageBox(s, v, MB_ICONQUESTION | MB_YESNOCANCEL)){
			case IDYES:
				if(!bBlitz){
					ChangeTeamCapital(nTeam, teamArray[nTeam].m_money - nBid);
					ChangeTeamScore(nTeam, teamArray[nTeam].m_points + 1);
				}else{
					if(nBlitzTeam != nTeam)
						ChangeTeamCapital(nTeam, teamArray[nTeam].m_money - nBid);
					if(bBlitz && (nBlitz == 3)){
						ChangeTeamScore(nTeam, teamArray[nTeam].m_points + 1);
						bBlitz = false;
					}
					nBlitzTeam = nTeam;
					nBlitz++;			
				}

				OnBnClickedReset();
				break;
			case IDNO:
				if(!bBlitz || (bBlitz && (nBlitzTeam != nTeam)))
					ChangeTeamCapital(nTeam, teamArray[nTeam].m_money - nBid);
				if(bBlitz) nBlitzTeam = -1;
				SetCounter(MAX, BLACK);
				currStartTime = timeGetTime();
				if(bTimerOld){			
					ResetTimer(true);
					if(currSpeed < 4){
						currSpeed++;
						m_questionvalue.SetCurSel(currSpeed - 1);
					}
				}//else: pressed the button when the question was being read
//				mcrRestart(&hComPort, &mask);
				break;
			case IDCANCEL:
				currStartTime = timeGetTime() - oldElapsed;
				ResetTimer(bTimerOld);
				break;
		}	
		bAnswering = false;

		labelSold.SetText("");
		m_bidderName.SetText("");
		InvalidateCounter();
		break;

	case GAMEBRAINMULT:
		BMSTATE oldcurrBMState;
		oldcurrBMState = currBMState;
		bAnswering = true;

		switch(currBMState){
		case BMQUESTION:
			labelSold.SetFontSize(72);
			labelSold.SetTextColor(BLACK);
			labelSold.SetText("");
			m_bidderName.SetTextColor(BLACK);
			m_bidderName.SetText(teamArray[nTeam].m_name);
			teamArray[nTeam].enabled = false;
			PlaySound(_T("window.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			s.Format(" \"%s\" ( %d)  .",teamArray[nTeam].m_name,teamArray[nTeam].m_label);
			currBMState = BMANSWERING;
			MessageBox(s, "", MB_ICONEXCLAMATION | MB_OK);
			currBMState = oldcurrBMState;
			SetCounter(-1, RED);
			if(nCanAnswer == 1){
				QuestionExpires(); // shouldn't happen
			}else if(nCanAnswer == 2){
				if(currBMState == BMBEEP1)
					currBMState = BMMINUTE;
				else if(currBMState == BMBEEP2)
					currBMState = BMSECOND;
				else 
					OnBnClickedStart60();
				currStartTime = timeGetTime();
			}else{
				if((currBMState == BMBEEP1) || (currBMState == BMBEEP2)) MakeBeepBM(currBMState);
			}
			m_bidderName.SetText("");
			labelSold.SetText("");
			InvalidateCounter();
			break;
		case BMANSWERING:
			break;
		case BMBEEP1:
		case BMBEEP2:
		case BMMINUTE:
		case BMSECOND:
			currBMState = BMANSWERING;
			SetCounter(-1,BLACK); // clear the display
			labelSold.SetFontSize(44);
			labelSold.SetTextColor(GREEN);
			labelSold.SetText(" ");
			m_bidderName.SetTextColor(GREEN);
			m_bidderName.SetText(teamArray[nTeam].m_name);

			PlayTeamSound(nTeam);

			s.Format("  \"%s\" ( %d).  ?",teamArray[nTeam].m_name,teamArray[nTeam].m_label);
			switch(MessageBox(s, " " + strElapsed, MB_ICONQUESTION | MB_YESNOCANCEL)){
			case IDYES:
				ChangeTeamScore(nTeam, teamArray[nTeam].m_points + m_questionvalue.GetCurSel() + 1);
				m_questionvalue.SetCurSel(0);
				OnBnClickedReset();
			break;
			case IDNO:
				SetCounter(BMSECONDMAX, BLACK);
				teamArray[nTeam].enabled = false;
				currStartTime = timeGetTime();
				if(nCanAnswer == 1)
					QuestionExpires();
				else if(nCanAnswer == 2) 
					currBMState = BMSECOND;
				else MakeBeepBM(BMBEEP2); // also sets the state
				break;
			case IDCANCEL:
				currStartTime = timeGetTime() - oldElapsed;
				currBMState = oldcurrBMState;
				break;
			}
			m_bidderName.SetText("");
			labelSold.SetText("");
			InvalidateCounter();
			break;
		}	
		bAnswering = false;
		break;


	case GAMEBRAINRING:
		BRSTATE oldcurrBRState;
		oldcurrBRState = currBRState;
		bAnswering = true;

		if((nCanAnswer == 1) && ((currBRState == BRQUESTION) || (currBRState == BRDELAY)))
			currBRState = BRBEEP1; // no false start with one player

		switch(currBRState){
		case BRQUESTION:
		case BRDELAY:
			currBRState = BRQUESTION;
			labelSold.SetFontSize(72);
			labelSold.SetTextColor(BLACK);
			labelSold.SetText("");
			labelSold.BringWindowToTop();
			m_bidderName.SetTextColor(BLACK);
			m_bidderName.SetText(teamArray[nTeam].m_name);
			teamArray[nTeam].enabled = false;
			PlaySound(_T("window.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			s.Format(" \"%s\" ( %d)  .",teamArray[nTeam].m_name,teamArray[nTeam].m_label);
			currBRState = BRANSWERING;
			MessageBox(s, "", MB_ICONEXCLAMATION | MB_OK);
			SetCounter(-1, RED);
			currBRState = oldcurrBRState;
			m_bidderName.SetText("");
			labelSold.SetText("");
			InvalidateCounter();
			break;
		case BRANSWERING:
			break;
		case BRBEEP1:
		case BRBEEP2:
		case BRMINUTE:
		case BRSECOND:
			currBRState = BRANSWERING;
			SetCounter(-1,BLACK); // clear the display
			labelSold.SetFontSize(44);
			labelSold.SetTextColor(GREEN);
			labelSold.SetText(" ");
			m_bidderName.SetTextColor(GREEN);
			m_bidderName.SetText(teamArray[nTeam].m_name);
			PlayTeamSound(nTeam);

			s.Format("  \"%s\" ( %d).  ?",teamArray[nTeam].m_name,teamArray[nTeam].m_label);
			switch(MessageBox(s, " " + strElapsed, MB_ICONQUESTION | MB_YESNOCANCEL)){
			case IDYES:
				ChangeTeamScore(nTeam, teamArray[nTeam].m_points + m_questionvalue.GetCurSel() + 1);
				m_questionvalue.SetCurSel(0);
				OnBnClickedReset();
			break;
			case IDNO:
				SetCounter(BRSECONDMAX, BLACK);
				teamArray[nTeam].enabled = false;
				currStartTime = timeGetTime();
				if(nCanAnswer == 1)
					QuestionExpires();
				else 
					if(nCanAnswer == 2) 
						currBRState = BRSECOND;
				else MakeBeepBR(BRBEEP2); // also sets the state
				break;
			case IDCANCEL:
				currStartTime = timeGetTime() - oldElapsed;
				currBRState = oldcurrBRState;
				break;
			}
			m_bidderName.SetText("");
			labelSold.SetText("");
			InvalidateCounter();
			break;
		}	
		bAnswering = false;
		break;
	case GAMESVOYAK:
		SISTATE oldcurrSIState;
		oldcurrSIState = currSIState;

		switch(currSIState){
		case SIANSWERING:
			break;
		case SICOOLOFF:
			PlaySound(_T("bummer.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			break;
		case SITIMER:
		case SIBREAK:
			currSIState = SIANSWERING;
			SetCounter(-1,BLACK); // clear the display
			if(oldcurrSIState == SITIMER){
				labelSold.SetTextColor(GREEN);
				m_bidderName.SetTextColor(GREEN);
			}else{
				labelSold.SetTextColor(RED);
				m_bidderName.SetTextColor(RED);
			}

			labelSold.SetFontSize(44);
			labelSold.SetText("");
			m_bidderName.SetText(teamArray[nTeam].m_name);
			//PlaySound(_T("hammer.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			PlayTeamSound(nTeam);

			s.Format(" %s ( %d).  ?",teamArray[nTeam].m_name,teamArray[nTeam].m_label);
			int nCost = (m_questionvalue.GetCurSel() + 1) * 10 * (BST_CHECKED == m_multiply2.GetCheck()? 2 : 1);
			switch(MessageBox(s, " " + strElapsed, MB_ICONQUESTION | MB_YESNOCANCEL)){
			case IDYES:
				ChangeTeamScore(nTeam, teamArray[nTeam].m_points + nCost);
				m_questionvalue.SetCurSel((m_questionvalue.GetCurSel() + 1) % 5);
				OnBnClickedReset();
				if(m_questionvalue.GetCurSel() == 0)
					PlaySound(_T("newtopic.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			break;
			case IDNO:
				ChangeTeamScore(nTeam, teamArray[nTeam].m_points - nCost);
				teamArray[nTeam].enabled = false;
				currStartTime = timeGetTime();
				if(nCanAnswer == 1)
					QuestionExpires();
				else{
					currSIState = oldcurrSIState;
					if(currSIState == SITIMER) SetCounter(SISECONDMAX, BLACK);
				}
				break;
			case IDCANCEL:
				currStartTime = timeGetTime() - oldElapsed;
				currSIState = oldcurrSIState;
				break;
			}
			m_bidderName.SetText("");
			labelSold.SetText("");
			InvalidateCounter();
			break;
		}	
		break;
	}
}

bool CcountdownDlg::CanAnswer(int nTeam){
	if(teamArray[nTeam].m_name.IsEmpty() || (teamArray[nTeam].m_label == 0)) return false;

	switch(currGame){
		case GAMEBRAINCION:
			if(bBlitz && (nBlitzTeam != -1)) return nTeam == nBlitzTeam;
			return teamArray[nTeam].m_money >= currCounter;
		case GAMEBRAINMULT:
			return teamArray[nTeam].enabled;
		case GAMEBRAINRING:
			return teamArray[nTeam].enabled;
		case GAMESVOYAK:
			return teamArray[nTeam].enabled;
		default:
			ASSERT(false);
	}
}

void CcountdownDlg::ProcessIntroduction(int nButton){
	for(int j = 0; j < currTeams; j++)
		if(&(pSynthesis->m_teams.teamEntries[j].m_tbutton) == pSynthesis->m_teams.GetFocus()) 
			break;

	if(j == currTeams) MessageBeep(MB_ICONEXCLAMATION);
		else{
			for(int i = 0; i < j; i++) 
				if(teamArray[i].m_label == nButton + 1){ // if the same button above on the list is selected, complain and do nothing
					MessageBeep(MB_ICONEXCLAMATION);
					return;
				}

			ChangeTeamButton(j, nButton + 1);
			UpdateScoreCards();
			PlayTeamSound(j);

			if((j < currTeams - 1) && (teamArray[j + 1].m_name != "")){
				pSynthesis->m_teams.teamEntries[j + 1].m_tbutton.SetFocus();
			}else{
				pSynthesis->m_teams.OnBnClickedButtonintro();
			}
		}
}

unsigned short CcountdownDlg::RemoveBounce(unsigned short mask, unsigned long timer)
{
	for(int i = 0; i < MCR_BUTTONS; i++)
		if(mask & (1 << i)){
			if(arAntiBounce[i] + BOUNCECUTOFF > timer)
				mask ^= (1 << i);
			else
				arAntiBounce[i] = timer;
		}
	return mask;
}

void CcountdownDlg::OnTimer(UINT nIDEvent)
{
	switch(nIDEvent){
		case EVENTUPDATE:
			UpdateCounter();
			UpdateScores();
			break;
		case EVENTPOLL:
			if(	mcrCheckMsg(&hComPort)){
				mcrEvent *evt;
				int count;
				mcrGetMsgs(&hComPort, &evt, &count);

				for(int i = 0; i < count; i++)
					evt[i].mask = RemoveBounce(evt[i].mask, evt[i].timer);

				if(bIntroduction){
					if(count > 0) MessageBeep(MB_ICONEXCLAMATION);
					for(int i = 0; i < currTeams; i++) 
						if(evt[0].mask & (1 << i))
							ProcessIntroduction(i);
				}else if(!bAnswering){
					for(int i = 0; i < count; i++){
						switch(currGame){
							case GAMEBRAINCION:
								break;
							case GAMEBRAINMULT:
								if(evt[i].mask & (1 << HOSTBUTTON)){
									if(currBMState == BMBREAK){
										MessageBeep(MB_OK);
										OnBnClickedStart60();
									}
									else if(currBMState == BMQUESTION)
										OnBnClickedStart30();
								}
								break;
							case GAMEBRAINRING:
								if(evt[i].mask & (1 << HOSTBUTTON)){
									if(currBRState == BRBREAK){
										MessageBeep(MB_OK);
										OnBnClickedStart60();
									}
									else if(currBRState == BRQUESTION)
										OnBnClickedStart30();
								}
								break;
							case GAMESVOYAK:
								if(evt[i].mask & (1 << HOSTBUTTON)){
									if(currSIState == SIBREAK){
										MessageBeep(MB_OK);
										OnBnClickedStart60();
									}
								}
								break;
						}
						int c = 0;
						int j;
						for(j = 0; j < currTeams; j++)
							if((teamArray[j].m_label > 0) && (evt[i].mask & (1 << (teamArray[j].m_label - 1))) && CanAnswer(j)) c++;
						if(c == 0) continue;
						int cc = 0;
						for(j = 0; j < currTeams; j++) 
							if((teamArray[j].m_label > 0) && (evt[i].mask & (1 << (teamArray[j].m_label - 1))) && CanAnswer(j)){
								int coin = rand();
								if((coin % c)  <= cc) break;
								cc++;
							}
						if( j >= currTeams) ASSERT ("bad luck");
						ProcessBid(j, currCounter);
						break; // exit the loop
					}
				}
				free (evt);
			}
			break;
		case EVENTSICOOLOFF:
			KillTimer(EVENTSICOOLOFF); // onetime event
			if(currSIState == SICOOLOFF)
				currSIState = SIBREAK;
			break;
		case EVENTDELAY:
			KillTimer(EVENTDELAY); // onetime event
			if(currBRState == BRDELAY)
				MakeBeepBR(BRBEEP1);
			break;
	}
	CPropertyPage::OnTimer(nIDEvent);	
}

void CcountdownDlg::ResetTimer(bool newTimer){
	bTimer = newTimer;
	if(bTimer){
//		CBStop.SetFocus();
	}
}

void CcountdownDlg::OnBnClickedStop()
{
//	int coin = rand();
//	ProcessBid(coin % 3, currCounter);
}

void CcountdownDlg::OnBnClickedStart60()
{
	switch(currGame){
		case GAMEBRAINCION:
			currStartTime = timeGetTime();
			ResetTimer(true);
//			currSpeed = 1;
			break;
		case GAMEBRAINMULT:
			m_bidderName.SetText("");
			labelSold.SetText("");
			SetCounter(MAX, RED);
			currBMState = BMQUESTION;
			CBStart30.SetFocus();
			break;
		case GAMEBRAINRING:
			m_bidderName.SetText("");
			labelSold.SetText("");
			SetCounter(MAX, RED);
			currBRState = BRQUESTION;
			CBStart30.SetFocus();
			break;
		case GAMESVOYAK:
			currStartTime = timeGetTime();
			m_bidderName.SetText("");
			labelSold.SetText("");
			SetCounter(SIMAX, BLACK);
			currSIState = SITIMER;
			break;
	}
}

void CcountdownDlg::MakeBeepBR(BRSTATE newBRState){
	currBRState = newBRState;
	switch(newBRState){
		case BRDELAY:
			SetTimer(EVENTDELAY, 200+(rand() % 500), NULL); 
			break;
		case BRBEEP1:
            SetCounter(MAX, BLACK);
			break;
		case BRBEEP2:
			SetCounter(BRSECONDMAX, BLACK);
			break;
	}
	if((newBRState == BRBEEP1) || (newBRState == BRBEEP2)){ 
		currStartTime = timeGetTime();
		PlaySound(_T("1sec.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
	}
}

void CcountdownDlg::MakeBeepBM(BMSTATE newBMState){
	if(newBMState == BMBEEP1) 
		SetCounter(MAX, BLACK);
	else 
		SetCounter(BMSECONDMAX, BLACK);
	currStartTime = timeGetTime();
	PlaySound(_T("1sec.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
	currBMState = newBMState;
}

void CcountdownDlg::OnBnClickedStart30()
{
	switch(currGame){
		case GAMEBRAINCION:
			currStartTime = timeGetTime();
			ResetTimer(true);
			currSpeed = 2;
			break;
		case GAMEBRAINMULT:
			MakeBeepBM(BMBEEP1);
			break;
		case GAMEBRAINRING:
			MakeBeepBR(BRDELAY);
			break;
		case GAMESVOYAK:
			break;
	}
}

void CcountdownDlg::OnBnClickedResume()
{
	if(!bTimer){
		currStartTime = timeGetTime() - currElapsed;
		ResetTimer(true);
	}
}

void CcountdownDlg::QuestionExpires(){
	int nValue;
	switch(currGame){
	case GAMEBRAINRING:
	case GAMEBRAINMULT:
		nValue = m_questionvalue.GetCurSel() + 1;
		if(nValue < 3) nValue++;
		m_questionvalue.SetCurSel(nValue - 1);
		PlaySound(_T("balloon.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
		OnBnClickedReset();
		break;
	case GAMESVOYAK:
		m_questionvalue.SetCurSel((m_questionvalue.GetCurSel() + 1) % 5);
		PlaySound(_T("beep.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
		OnBnClickedReset();
		currSIState = SICOOLOFF;
		SetTimer(EVENTSICOOLOFF, 1000 * SITIMECOOLOFF, NULL); 
		if(m_questionvalue.GetCurSel() == 0)
			PlaySound(_T("newtopic.wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
		break;
	}
}

void CcountdownDlg::OnDestroy()
{
	CPropertyPage::OnDestroy();

	((CcountdownApp *)AfxGetApp())->m_hwndDialog = NULL;
}

void CcountdownDlg::OnCancel()
{
	return;
}

BOOL CcountdownDlg::OnSetActive(){
	if(CPropertyPage::OnSetActive()){
		InvalidateCounter();
		return TRUE;
	}else 
		return FALSE;
}

void CcountdownDlg::OnBnClickedReset()
{
	// TODO: Add your control notification handler code here
	switch(currGame){
		case GAMEBRAINCION:
			labelSold.SetText("");
			m_bidderName.SetText("");
			ResetTimer(false);
			SetCounter(MAX, BLACK);
			if(!bBlitz){
				currSpeed = 1;
				m_questionvalue.SetCurSel(0);
				m_multiply2.SetCheck(false);
			}else{
				currSpeed = 3;
				m_questionvalue.SetCurSel(2);
				m_multiply2.SetCheck(true);
			}
			break;
		case GAMEBRAINMULT:
			labelSold.SetText("");
			m_bidderName.SetText("");
			SetCounter(-1, BLACK);
			currBMState = BMBREAK;
			break;

		case GAMEBRAINRING:
			labelSold.SetText("");
			m_bidderName.SetText("");
			SetCounter(-1, BLACK);
			currBRState = BRBREAK;
			break;

		case GAMESVOYAK:
			labelSold.SetText("");
			m_bidderName.SetText("");
			SetCounter(-1, BLACK);
			currSIState = SIBREAK;
			break;
	}

	for(int i = 0; i < currTeams; i++)
		teamArray[i].enabled = true;

	UpdateCounter();
	UpdateScores();

	InvalidateCounter();

	for(int i = 0; i < MCR_BUTTONS; i++)
		arAntiBounce[i] = - BOUNCECUTOFF;
	
	if(	mcrCheckMsg(&hComPort)){
				mcrEvent *evt;
				int count;
				mcrGetMsgs(&hComPort, &evt, &count);
				free (evt);
	}

	mcrStop (&hComPort);

	unsigned short mask;
	if (mcrRestart(&hComPort, &mask))
		printf("Start fail mask = 0x%x\n", mask);
	else{
		MessageBox("Error: mcrRestart() timed out", "Error", MB_ICONERROR | MB_OK);
		printf("Error: mcrRestart() timed out\n");
	}
	CBStart60.SetFocus();
}


void CcountdownDlg::OnBnClickedCheck1()
{
	switch(currGame){
		case GAMEBRAINCION:
			if(m_multiply2.GetCheck()){
				currSpeed = 3;		
				bBlitz = true;
				nBlitzTeam = -1;
				nBlitz = 1;
			}
			else{
				currSpeed = 1;
				bBlitz = false;
				nBlitzTeam = -1;
				nBlitz = 0;
			}
			m_questionvalue.SetCurSel(currSpeed - 1);
			break;
		case GAMEBRAINMULT:
			break;
		case GAMEBRAINRING:
			break;
		case GAMESVOYAK:
			for(int i = 0; i < 5; i++)
				m_questionvalue.DeleteString(0);

			for(int i = 0; i < 5; i++){
				CString s;
				s.Format("%d",(i + 1) * 10 * (BST_CHECKED == m_multiply2.GetCheck()? 2 : 1));
				m_questionvalue.AddString(s);
			}
			m_questionvalue.SetCurSel(0);
			break;
	}
}

void CcountdownDlg::OnCbnSelchangeCombo1()
{
	switch(currGame){
		case GAMEBRAINCION:
			if(m_questionvalue.GetCurSel() >= 0)
				currSpeed = m_questionvalue.GetCurSel() + 1;
			break;
		case GAMEBRAINMULT:
			break;
		case GAMEBRAINRING:
			break;
		case GAMESVOYAK:
			break;
	}
}

void CcountdownDlg::SetTeamName(int n, CString s){
	m_teamcards[n].m_tname.SetWindowText(s);
}

void CcountdownDlg::PlayTeamSound(int nTeam){
	CString sTeamName; sTeamName.Format("%d",nTeam);
	switch(currGame){
		case GAMEBRAINCION:
		case GAMEBRAINMULT:
		case GAMESVOYAK:
			PlaySound(_T("click" + sTeamName + ".wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			break;
		case GAMEBRAINRING:
			PlaySound(_T("hammer" + sTeamName + ".wav"), NULL, SND_ASYNC | SND_NODEFAULT | SND_FILENAME);
			break;
	}	
}


void CcountdownDlg::OnBnClickedCheck2()
{
	if(m_transparent.GetCheck()){
		pSynthesis->ModifyStyleEx(0, WS_EX_LAYERED, 0);
		pSynthesis->SetLayeredWindowAttributes(RGB(0,0,0), 128, LWA_ALPHA);
	}else
		pSynthesis->SetLayeredWindowAttributes(RGB(0,0,0), 255, LWA_ALPHA);
}

void CcountdownDlg::ArrangeScores(){
	int nteamsinplay = 0;
	for(int i = 0; i < currTeams; i++) 
		if(!teamArray[i].m_name.IsEmpty()) 
			nteamsinplay++;

	if(nteamsinplay < 3)
		nteamsinplay = 3;

	CRect rect;
	m_labelbutton.GetWindowRect(&rect); 
	int ytop = rect.bottom;
	CBStart60.GetWindowRect(&rect);
	int ybottom = rect.top;
	int ysize = (ybottom - ytop - YGAPTOP - YGAPBOTTOM + YGAPBETWEEN) / nteamsinplay;
	if(ysize > YHEIGHTMAX)
		ysize = YHEIGHTMAX;

	m_labelbutton.GetClientRect(&rect);
	int yclienttop = rect.bottom;

	int norder = 0;
	for(int i = 0; i < currTeams; i++) 
		if(!teamArray[i].m_name.IsEmpty()){
			int ylabeltop = yclienttop + norder * (ysize + YGAPBETWEEN) + YGAPTOP;
			CRect rect;
			m_teamcards[i].m_tname.GetWindowRect(&rect); ScreenToClient(rect);
			int nwidth = rect.Width();			
			m_teamcards[i].m_tname.MoveWindow(rect.left, ylabeltop, nwidth, ysize);

			m_teamcards[i].m_tnum.GetWindowRect(&rect); ScreenToClient(rect);
			nwidth = rect.Width();			
			m_teamcards[i].m_tnum.MoveWindow(rect.left, ylabeltop, nwidth, ysize);

			m_teamcards[i].m_tpoints.GetWindowRect(&rect); ScreenToClient(rect);
			nwidth = rect.Width();			
			m_teamcards[i].m_tpoints.MoveWindow(rect.left, ylabeltop, nwidth, ysize);

			m_teamcards[i].m_tmoney.GetWindowRect(&rect); ScreenToClient(rect);
			nwidth = rect.Width();			
			m_teamcards[i].m_tmoney.MoveWindow(rect.left, ylabeltop, nwidth, ysize);

			norder++;
		}
		
	m_scorefont.DeleteObject();
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));       // zero out structure
	lf.lfHeight = ysize - 3;               // request the font's size
	strcpy(lf.lfFaceName, "Arial");        // request a face name "Arial"
	m_scorefont.CreateFontIndirect(&lf);   // create the font

	for(int i = 0; i < currTeams; i++){
		switch(currGame){
		case GAMEBRAINCION:
				m_teamcards[i].m_tmoney.SetFont(&m_scorefont);
				break;
		case GAMEBRAINMULT:
				break;
		case GAMEBRAINRING:
				break;
		case GAMESVOYAK:
				break;
		}
		m_teamcards[i].m_tnum.SetFont(&m_scorefont);
		m_teamcards[i].m_tname.SetFont(&m_scorefont);
		m_teamcards[i].m_tpoints.SetFont(&m_scorefont);
	}

}