// Copyright 2003, Ilya Mironov & Dmitry Teytelman

#include "stdafx.h"
#include "resource.h"
#include "synthesis.h"
#include "scoretable.h"
#include "countdown.h"

int currTeams = 8;
int currSeedCapital = 200;
GAMETYPE currGame = GAMEBRAINCION;


char delimeter = '|';

CTeamRecord teamArray[MAXTEAMS];


void WriteTransaction(int i){
	CStdioFile fileLog(logName, CFile::typeText | CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite);
	fileLog.SeekToEnd();
	CString s;
	s.Format("%d|%s|%d|%d|%d\n",i,teamArray[i].m_name,teamArray[i].m_label,teamArray[i].m_money,teamArray[i].m_points);

	fileLog.WriteString(s);
	fileLog.Close();
}

void ReadFile(){
	CStdioFile fileLog(logName, CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText | CFile::modeRead);
	CString ss;

	for(int i = 0; i < currTeams; i++){
		teamArray[i].m_label = 0;
		teamArray[i].m_name = "";
		teamArray[i].m_money = 0;
		teamArray[i].m_points = 0;
	}

	for (;;){ 
		if (fileLog.ReadString(ss)){
			CString s = ss;
			int pos = 0;
			int i;
			pos = ss.Find(delimeter);
			if(pos == -1) continue;
			s = ss.Left(pos);
			ss = ss.Right(ss.GetLength() - 1 - pos);
			if(1 != sscanf(s,"%d",&i)) continue;
			CString name;
			pos = ss.Find(delimeter); 
			if(pos == -1) continue;
			name = ss.Left(pos);ss = ss.Right(ss.GetLength() - 1 - pos);
			int num;
			pos = ss.Find(delimeter); 
			if(pos == -1) continue;
			s = ss.Left(pos);ss = ss.Right(ss.GetLength() - 1 - pos);
			if(1 != sscanf(s,"%d",&num)) continue;
			int money;
			pos = ss.Find(delimeter); 
			if(pos == -1) continue;
			s = ss.Left(pos);ss = ss.Right(ss.GetLength() - 1 - pos);
			if(1 != sscanf(s,"%d",&money)) continue;
			int points;
			if(1 != sscanf(ss,"%d",&points)) continue;

			for(int j = 0; j < currTeams; j++)
				if((j != i) && (teamArray[j].m_label == num) && (num > 0))
					teamArray[j].m_label = 0;		// a conflict found

			teamArray[i].m_label = num;
			teamArray[i].m_name = name;
			teamArray[i].m_money = money;
			teamArray[i].m_points = points;
		}else break;
	} 
	fileLog.Close();
	UpdateScoreCards();
}

void ChangeTeamName(int i, CString name, bool bWrite)
{ 
	if (teamArray[i].m_name != name){
		if(teamArray[i].m_name == "") 
			teamArray[i].m_money = currSeedCapital;
		teamArray[i].m_name = name;
		if(bWrite) WriteTransaction(i);
	}
}

void ChangeTeamButton(int i, int n, bool bWrite){
	for(int j = 0; j < currTeams; j++)  
		if((j != i) && (teamArray[j].m_label == n) && (n > 0)){
			teamArray[j].m_label = 0;		// a conflict found
			MessageBeep(MB_ICONASTERISK);
			if(bWrite) WriteTransaction(j);
		}	
	if(teamArray[i].m_label != n){
		teamArray[i].m_label = n;
		if(bWrite) WriteTransaction(i);
	}
}

void ChangeTeamScore(int i, int p, bool bWrite){
	teamArray[i].m_points = p;
	if(bWrite) WriteTransaction(i);
	UpdateScoreCards();
}

void ChangeTeamCapital(int i, int m, bool bWrite){
	teamArray[i].m_money = m;
	if(bWrite) WriteTransaction(i);
	UpdateScoreCards();
}

void UpdateScoreCards(){
	if(!pSynthesis)
		return;
	CcountdownDlg* pscore = NULL;
	if(pSynthesis->m_score->m_hWnd)
		pscore = pSynthesis->m_score;

	CTeams* pteams = NULL;
	if(pSynthesis->m_teams.m_hWnd)
		pteams = &pSynthesis->m_teams;

	for(int i = 0; i < currTeams; i++) 
		if(!teamArray[i].m_name.IsEmpty()){
			if(pscore){
				pscore->m_teamcards[i].m_tname.SetWindowText(teamArray[i].m_name);
				pscore->m_teamcards[i].m_tname.ShowWindow(SW_SHOW);
				CString s; 
				if(teamArray[i].m_label != 0)
					s.Format("%d", teamArray[i].m_label);
				else 
					s = "";

				if(currGame != GAMEBRAINRING){
					pscore->m_teamcards[i].m_tnum.SetWindowText(s);
					pscore->m_teamcards[i].m_tnum.ShowWindow(SW_SHOW);
				}

				s.Format("%d", teamArray[i].m_points);
				pscore->m_teamcards[i].m_tpoints.SetWindowText(s);
				pscore->m_teamcards[i].m_tpoints.ShowWindow(SW_SHOW);

				switch(currGame){
					case GAMEBRAINCION:
						s.Format("%d", teamArray[i].m_money);
						pscore->m_teamcards[i].m_tmoney.SetWindowText(s);
						pscore->m_teamcards[i].m_tmoney.ShowWindow(SW_SHOW);
						break;
					case GAMEBRAINMULT:
					case GAMEBRAINRING:
					case GAMESVOYAK:
						break;
				}
			}
			if(pteams){
				pteams->teamEntries[i].m_tname.SetWindowText(teamArray[i].m_name);
				pteams->teamEntries[i].m_tbutton.SetCurSel(teamArray[i].m_label);
			}
		}else{
			if(pscore){
				pscore->m_teamcards[i].m_tname.SetWindowText(teamArray[i].m_name);
				pscore->m_teamcards[i].m_tnum.SetWindowText("");
				pscore->m_teamcards[i].m_tpoints.SetWindowText("");
				pscore->m_teamcards[i].m_tmoney.SetWindowText("");
				pscore->m_teamcards[i].m_tname.ShowWindow(SW_HIDE);
				pscore->m_teamcards[i].m_tnum.ShowWindow(SW_HIDE);
				pscore->m_teamcards[i].m_tpoints.ShowWindow(SW_HIDE);
				pscore->m_teamcards[i].m_tmoney.ShowWindow(SW_HIDE);

			}
			if(pteams){
				pteams->teamEntries[i].m_tname.SetWindowText(teamArray[i].m_name);
				pteams->teamEntries[i].m_tbutton.SetCurSel(-1);
			}
		}

	if(pscore){
			UpdateScores();
			pscore->ArrangeScores();
	}
}

void UpdateScores(){	
	CcountdownDlg* pscore = pSynthesis->m_score;
	for(int i = 0; i < currTeams; i++){
		pscore->m_teamcards[i].m_tname.EnableWindow(pscore->CanAnswer(i));
		pscore->m_teamcards[i].m_tnum.EnableWindow(pscore->CanAnswer(i));
		pscore->m_teamcards[i].m_tpoints.EnableWindow(pscore->CanAnswer(i));

		switch(currGame){
		case GAMEBRAINCION:
				pscore->m_teamcards[i].m_tmoney.EnableWindow(pscore->CanAnswer(i));
				break;
		case GAMEBRAINMULT:
				break;
		case GAMEBRAINRING:
				break;
		case GAMESVOYAK:
				break;
		}
	}
}


void ResetScores(int nSeedCapital){
	for(int i = 0; i < currTeams; i++){
		teamArray[i].m_points = 0;
		teamArray[i].m_money = nSeedCapital;
		if(teamArray[i].m_name != "")
			WriteTransaction(i);
	}
	UpdateScoreCards();
}