// synthesis.cpp : implementation file
//
// Copyright 2003, Ilya Mironov & Dmitry Teytelman


#include "stdafx.h"
#include "countdown.h"
#include "synthesis.h"
#include "scoretable.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSynthesis

IMPLEMENT_DYNAMIC(CSynthesis, CPropertySheet)

CSynthesis::CSynthesis(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddControlPages();

	// TODO :: Add the pages for the rest of the controls here.
}

CSynthesis::CSynthesis(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddControlPages();
}

CSynthesis::~CSynthesis()
{
	if(pm_countdownDlg)
		delete pm_countdownDlg;
}

void CSynthesis::AddControlPages()
{
	switch(currGame){
		case GAMEBRAINCION:
			pm_countdownDlg = new CcountdownDlg();
			break;
		case GAMEBRAINRING:
			pm_countdownDlg = new CcountdownDlgBrain();
			break;
		case GAMEBRAINMULT:
			pm_countdownDlg = new CcountdownDlg();
			break;
		case GAMESVOYAK:
			pm_countdownDlg = new CcountdownDlg();
			break;
	}

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_psh.dwFlags |= PSP_USEHICON;
	m_psh.hIcon = m_hIcon;
	m_psh.dwFlags |= PSH_NOAPPLYNOW;    // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;		// Lose the Help button

	pm_countdownDlg->m_pPSP->dwFlags &= ~PSP_HASHELP;  // Lose the Help button
	m_teams.m_pPSP->dwFlags &= ~PSP_HASHELP;  // Lose the Help button
	m_logtab.m_pPSP->dwFlags &= ~PSP_HASHELP;  // Lose the Help button
	
	m_score = NULL;

	AddPage(pm_countdownDlg);
	AddPage(&m_teams);
	AddPage(&m_logtab);

	m_score = pm_countdownDlg;

	ReadFile();
}

BEGIN_MESSAGE_MAP(CSynthesis, CPropertySheet)
	//{{AFX_MSG_MAP(CSynthesis)
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSynthesis message handlers

BOOL CSynthesis::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}



	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	UpdateScoreCards();

//	m_teams.SetWindowText("");
//	m_logtab.SetWindowText("");

	return bResult;
}
HCURSOR CSynthesis::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSynthesis::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CPropertySheet::OnSysCommand(nID, lParam);
	}
}

void CSynthesis::OnCancel(){
	return;
}

BOOL CSynthesis::OnQueryCancel() 
{
   if (AfxMessageBox(" ,   ?", MB_YESNO) == IDNO)
         return FALSE;  
   return TRUE;
//   return CPropertyPage::OnQueryCancel();
}